// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockPipelines is an autogenerated mock type for the Pipelines type
type MockPipelines struct {
	mock.Mock
}

// CreatePipeline provides a mock function with given fields: ctx, pipeline
func (_m *MockPipelines) CreatePipeline(ctx context.Context, pipeline *models.Pipeline) (*models.Pipeline, error) {
	ret := _m.Called(ctx, pipeline)

	if len(ret) == 0 {
		panic("no return value specified for CreatePipeline")
	}

	var r0 *models.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Pipeline) (*models.Pipeline, error)); ok {
		return rf(ctx, pipeline)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Pipeline) *models.Pipeline); ok {
		r0 = rf(ctx, pipeline)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Pipeline) error); ok {
		r1 = rf(ctx, pipeline)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineByID provides a mock function with given fields: ctx, id
func (_m *MockPipelines) GetPipelineByID(ctx context.Context, id string) (*models.Pipeline, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineByID")
	}

	var r0 *models.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Pipeline, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Pipeline); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineByPRN provides a mock function with given fields: ctx, prn
func (_m *MockPipelines) GetPipelineByPRN(ctx context.Context, prn string) (*models.Pipeline, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineByPRN")
	}

	var r0 *models.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Pipeline, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Pipeline); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineByReleaseID provides a mock function with given fields: ctx, releaseID
func (_m *MockPipelines) GetPipelineByReleaseID(ctx context.Context, releaseID string) (*models.Pipeline, error) {
	ret := _m.Called(ctx, releaseID)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineByReleaseID")
	}

	var r0 *models.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Pipeline, error)); ok {
		return rf(ctx, releaseID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Pipeline); ok {
		r0 = rf(ctx, releaseID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, releaseID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelines provides a mock function with given fields: ctx, input
func (_m *MockPipelines) GetPipelines(ctx context.Context, input *GetPipelinesInput) (*PipelinesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelines")
	}

	var r0 *PipelinesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelinesInput) (*PipelinesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelinesInput) *PipelinesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PipelinesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPipelinesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdatePipeline provides a mock function with given fields: ctx, pipeline
func (_m *MockPipelines) UpdatePipeline(ctx context.Context, pipeline *models.Pipeline) (*models.Pipeline, error) {
	ret := _m.Called(ctx, pipeline)

	if len(ret) == 0 {
		panic("no return value specified for UpdatePipeline")
	}

	var r0 *models.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Pipeline) (*models.Pipeline, error)); ok {
		return rf(ctx, pipeline)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Pipeline) *models.Pipeline); ok {
		r0 = rf(ctx, pipeline)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Pipeline) error); ok {
		r1 = rf(ctx, pipeline)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockPipelines creates a new instance of MockPipelines. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPipelines(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPipelines {
	mock := &MockPipelines{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
